## openvpn 2.7.0~beta2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
set(CMAKE_CONFIGURATION_TYPES "Release;Debug;ASAN")
project(openvpn)

# This CMake file implements building OpenVPN with CMAKE
#
# Note that this is *NOT* the official way to build openvpn on anything
# other than Windows/mingw despite working on other platforms too. You will need
# to add -DUNSUPPORTED_BUILDS=true to build on non Windows platforms.
#
# This cmake also makes a few assertions like lzo, lz4 being used
# and OpenSSL having version 1.1.1+ and generally does not offer the same
# configurability like autoconf

find_package(PkgConfig REQUIRED)
include(CheckSymbolExists)
include(CheckIncludeFiles)
include(CheckCCompilerFlag)
include(CheckLinkerFlag OPTIONAL)
include(CheckTypeSize)
include(CheckStructHasMember)
include(CTest)

option(UNSUPPORTED_BUILDS "Allow unsupported builds" OFF)

if (NOT WIN32 AND NOT ${UNSUPPORTED_BUILDS})
    message(FATAL_ERROR "Note: on Unix platform the official and supported build method is using autoconfig. CMake based build should be only used for Windows and internal testing/development.")
endif()

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/config.h")
    message(FATAL_ERROR "The top level source directory has a config.h file. Note that you can't mix in-tree autoconfig builds with out-of-tree cmake builds.")
endif ()

option(MBED "BUILD with mbed" OFF)
set(MBED_INCLUDE_PATH "" CACHE STRING "Path to mbed TLS include directory")
set(MBED_LIBRARY_PATH "" CACHE STRING "Path to mbed library directory")
option(WOLFSSL "BUILD with wolfSSL" OFF)
option(ENABLE_LZ4 "BUILD with lz4" ON)
option(ENABLE_LZO "BUILD with lzo" ON)
option(ENABLE_PKCS11 "BUILD with pkcs11-helper" ON)
option(USE_WERROR "Treat compiler warnings as errors (-Werror)" ON)
option(FAKE_ANDROID "Target Android but do not use actual cross compile/Android cmake to build for simple compile checks on Linux")

option(ENABLE_DNS_UPDOWN_BY_DEFAULT "Run --dns-updown hook by default" ON)
set(DNS_UPDOWN_PATH "${CMAKE_INSTALL_PREFIX}/libexec/openvpn/dns-updown" CACHE STRING "Default location for the DNS up/down script")

set(PLUGIN_DIR "${CMAKE_INSTALL_PREFIX}/lib/openvpn/plugins" CACHE FILEPATH "Location of the plugin directory")

# Create machine readable compile commands
option(ENABLE_COMPILE_COMMANDS "Generate compile_commands.json and a symlink for clangd to find it" OFF)
if (ENABLE_COMPILE_COMMANDS)
    if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/build AND NOT IS_SYMLINK ${CMAKE_CURRENT_SOURCE_DIR}/build)
        message(FATAL_ERROR "The top level source directory contains a 'build' file or directory. Please remove or rename it. CMake creates a symlink with that name during build.")
    endif()
    set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
    add_custom_target(
        symlink-build-dir ALL
        ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/build
        )
endif ()

# AddressSanitize - use CXX=clang++ CC=clang cmake -DCMAKE_BUILD_TYPE=asan to build with ASAN
set(CMAKE_C_FLAGS_ASAN
    "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
    CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
    FORCE)
set(CMAKE_CXX_FLAGS_ASAN
    "-fsanitize=address,undefined -fno-sanitize-recover=all -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
    CACHE STRING "Flags used by the C++ compiler during AddressSanitizer builds."
    FORCE)

function(check_and_add_compiler_flag flag variable)
    check_c_compiler_flag(${flag} ${variable})
    if (${variable})
        add_compile_options(${flag})
    endif()
endfunction()

if (MSVC)
    add_compile_definitions(
        _CRT_SECURE_NO_WARNINGS
        _CRT_NONSTDC_NO_DEPRECATE
        _WINSOCK_DEPRECATED_NO_WARNINGS
        )
    if (USE_WERROR)
        add_compile_options(/WX)
    endif ()
    add_compile_options(
        /MP
        /W2
        /sdl
        /Qspectre
        /guard:cf
        /FC
        /ZH:SHA_256
        "$<$<CONFIG:Release>:/GL>"
        "$<$<CONFIG:Release>:/Oi>"
        "$<$<CONFIG:Release>:/Gy>"
        "$<$<CONFIG:Release>:/Zi>"
        )
    add_link_options(
        /Brepro
        "$<$<CONFIG:Release>:/LTCG:incremental>"
        "$<$<CONFIG:Release>:/DEBUG:FULL>"
        "$<$<CONFIG:Release>:/OPT:REF>"
        "$<$<CONFIG:Release>:/OPT:ICF>"
        )
    if (${CMAKE_GENERATOR_PLATFORM} STREQUAL "x64" OR ${CMAKE_GENERATOR_PLATFORM} STREQUAL "x86")
        add_link_options("$<$<CONFIG:Release>:/CETCOMPAT>")
    endif()
else ()
    add_compile_options(-Wall -Wuninitialized)
    check_and_add_compiler_flag(-Wno-stringop-truncation NoStringOpTruncation)
    check_and_add_compiler_flag(-Wstrict-prototypes StrictPrototypes)
    check_and_add_compiler_flag(-Wold-style-definition OldStyleDefinition)
    add_compile_options(-Wconversion -Wno-sign-conversion)
    add_compile_options(-Wextra -Wno-sign-compare -Wno-type-limits -Wno-unused-parameter)
    # clang doesn't have the different levels but also doesn't include it in -Wextra
    check_and_add_compiler_flag(-Wimplicit-fallthrough=2 GCCImplicitFallthrough)
    if (WIN32)
        # Not sure how to deal with GetProcAddress
        add_compile_options(-Wno-cast-function-type)
    endif ()
    if (USE_WERROR)
        add_compile_options(-Werror)
    endif ()
endif ()

find_package(Python3 REQUIRED COMPONENTS Interpreter)
execute_process(
    COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/contrib/cmake/parse-version.m4.py ${CMAKE_CURRENT_SOURCE_DIR}/version.m4
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
include(${CMAKE_CURRENT_BINARY_DIR}/version.cmake)

set(OPENVPN_VERSION_MAJOR ${PRODUCT_VERSION_MAJOR})
set(OPENVPN_VERSION_MINOR ${PRODUCT_VERSION_MINOR})
set(OPENVPN_VERSION_PATCH ${PRODUCT_VERSION_PATCH})
set(OPENVPN_VERSION_RESOURCE ${PRODUCT_VERSION_RESOURCE})

set(CMAKE_C_STANDARD 11)

# Set the various defines for config.h.cmake.in
if (${CMAKE_SYSTEM_NAME} STREQUAL "Android" OR ${FAKE_ANDROID})
    set(TARGET_ANDROID YES)
    set(ENABLE_ASYNC_PUSH YES)
    set(ENABLE_SITNL YES)
    set(HAVE_LINUX_TYPES_H 1)
    # Wacky workaround as OpenSSL package detection is otherwise broken (https://stackoverflow.com/questions/45958214/android-cmake-could-not-find-openssl)
    list(APPEND CMAKE_FIND_ROOT_PATH ${OPENSSL_ROOT_DIR})
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(TARGET_LINUX YES)
    set(ENABLE_ASYNC_PUSH YES)
    set(ENABLE_LINUXDCO YES)
    set(ENABLE_SITNL YES)
    set(HAVE_DECL_SO_MARK YES)
    set(ENABLE_FEATURE_TUN_PERSIST 1)
    set(HAVE_LINUX_TYPES_H 1)
    set(ENABLE_DCO YES)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    set(TARGET_FREEBSD YES)
    set(ENABLE_DCO YES)
    link_libraries(-lnv)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    set(TARGET_OPENBSD YES)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "SunOS")
    set(TARGET_SOLARIS YES)
    set(HAVE_SYS_SOCKIO_H 1)
    link_libraries(-lnsl -lsocket -lresolv)
elseif (WIN32)
    set(ENABLE_DCO YES)
elseif (APPLE)
    set(TARGET_DARWIN YES)
else()
    message(FATAL_ERROR "Unknown system name: \"${CMAKE_SYSTEM_NAME}\"")
endif ()

if (UNIX)
    set(PATH_SEPARATOR /)
    set(ENABLE_PORT_SHARE YES)
    set(HAVE_SA_FAMILY_T YES)
elseif (WIN32)
    set(PATH_SEPARATOR \\\\)
    set(TARGET_WIN32 YES)
endif ()

check_include_files(unistd.h HAVE_UNISTD_H)
if (HAVE_UNISTD_H)
    check_symbol_exists(chroot unistd.h HAVE_CHROOT)
    check_symbol_exists(chdir unistd.h HAVE_CHDIR)
    check_symbol_exists(dup unistd.h HAVE_DUP)
    check_symbol_exists(dup2 unistd.h HAVE_DUP2)
    check_symbol_exists(fork unistd.h HAVE_FORK)
    check_symbol_exists(execve unistd.h HAVE_EXECVE)
    check_symbol_exists(ftruncate unistd.h HAVE_FTRUNCATE)
    check_symbol_exists(nice unistd.h HAVE_NICE)
    check_symbol_exists(setgid unistd.h HAVE_SETGID)
    check_symbol_exists(setuid unistd.h HAVE_SETUID)
    check_symbol_exists(setsid unistd.h HAVE_SETSID)
    check_symbol_exists(daemon "unistd.h;stdlib.h" HAVE_DAEMON)
    check_symbol_exists(getpeereid "unistd.h;sys/socket.h" HAVE_GETPEEREID)
endif()

check_include_files(grp.h HAVE_GRP_H)
if (HAVE_GRP_H)
    check_symbol_exists(getgrnam grp.h HAVE_GETGRNAM)
endif()
check_include_files(libgen.h HAVE_LIBGEN_H)
if (HAVE_LIBGEN_H)
    check_symbol_exists(basename libgen.h HAVE_BASENAME)
    check_symbol_exists(dirname libgen.h HAVE_DIRNAME)
endif()
check_include_files(pwd.h HAVE_PWD_H)
if (HAVE_PWD_H)
    check_symbol_exists(getpwnam pwd.h HAVE_GETPWNAM)
endif()
check_include_files(sys/epoll.h HAVE_SYS_EPOLL_H)
if (HAVE_SYS_EPOLL_H)
    check_symbol_exists(epoll_create sys/epoll.h HAVE_EPOLL_CREATE)
endif()
check_include_files(syslog.h HAVE_SYSLOG_H)
if (HAVE_SYSLOG_H)
    check_symbol_exists(openlog syslog.h HAVE_OPENLOG)
    check_symbol_exists(syslog syslog.h HAVE_SYSLOG)
endif()
check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
if (HAVE_SYS_MMAN_H)
    check_symbol_exists(mlockall sys/mman.h HAVE_MLOCKALL)
endif()
check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
if (HAVE_SYS_SOCKET_H)
    check_symbol_exists(sendmsg sys/socket.h HAVE_SENDMSG)
    check_symbol_exists(recvmsg sys/socket.h HAVE_RECVMSG)
    check_symbol_exists(getsockname sys/socket.h HAVE_GETSOCKNAME)
    # Checking for existence of structs with check_symbol_exists does not work,
    # so we use check_struct_hash_member with a member instead
    check_struct_has_member("struct cmsghdr" cmsg_len sys/socket.h HAVE_CMSGHDR)
endif()
check_include_files(sys/time.h HAVE_SYS_TIME_H)
if (HAVE_SYS_TIME_H)
    check_symbol_exists(gettimeofday sys/time.h HAVE_GETTIMEOFDAY)
    check_symbol_exists(getrlimit "sys/time.h;sys/resource.h" HAVE_GETRLIMIT)
endif()

check_symbol_exists(chsize io.h HAVE_CHSIZE)
check_symbol_exists(getrlimit sys/resource.h HAVE_GETRLIMIT)

# Some OS (e.g. FreeBSD) need some basic headers to allow
# including network headers
set(NETEXTRA sys/types.h)
check_include_files("${NETEXTRA};netinet/in.h" HAVE_NETINET_IN_H)
if (HAVE_NETINET_IN_H)
    list(APPEND NETEXTRA netinet/in.h)
endif ()

check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(dmalloc.h HAVE_DMALLOC_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(err.h HAVE_ERR_H)
check_include_files(linux/if_tun.h HAVE_LINUX_IF_TUN_H)
check_include_files(linux/sockios.h HAVE_LINUX_SOCKIOS_H)
check_include_files(netdb.h HAVE_NETDB_H)
check_include_files("${NETEXTRA};netinet/in6.h" HAVE_NETINET_IN_H)
check_include_files(net/if.h HAVE_NET_IF_H)
check_include_files("${NETEXTRA};net/if_tun.h" HAVE_NET_IF_TUN_H)
check_include_files(poll.h HAVE_POLL_H)
check_include_files("${NETEXTRA};resolv.h" HAVE_RESOLV_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
check_include_files("${NETEXTRA};sys/uio.h" HAVE_SYS_UIO_H)
check_include_files(sys/un.h HAVE_SYS_UN_H)
check_include_files(sys/wait.h HAVE_SYS_WAIT_H)

check_include_files("${NETEXTRA};netinet/ip.h" HAVE_NETINET_IP_H)
if (HAVE_NETINET_IP_H)
    set(CMAKE_EXTRA_INCLUDE_FILES netinet/ip.h)
    check_type_size("struct in_pktinfo" IN_PKTINFO)
    check_struct_has_member("struct in_pktinfo" ipi_spec_dst netinet/ip.h HAVE_IPI_SPEC_DST)
    check_type_size("struct msghdr" MSGHDR)
    set(CMAKE_EXTRA_INCLUDE_FILES)
endif()

find_program(IFCONFIG_PATH ifconfig)
find_program(IPROUTE_PATH ip)
find_program(ROUTE_PATH route)

if (${ENABLE_LZ4})
    pkg_search_module(liblz4 liblz4 REQUIRED IMPORTED_TARGET)
endif ()

if (${ENABLE_LZO})
    pkg_search_module(lzo2 lzo2 REQUIRED IMPORTED_TARGET)
endif ()

if (${ENABLE_PKCS11})
    pkg_search_module(pkcs11-helper libpkcs11-helper-1 REQUIRED IMPORTED_TARGET)
endif ()

function(check_mbed_configuration)
    if (NOT (MBED_INCLUDE_PATH STREQUAL "") )
        set(CMAKE_REQUIRED_INCLUDES ${MBED_INCLUDE_PATH})
    endif ()
    if (NOT (MBED_LIBRARY_PATH STREQUAL ""))

=== sample/sample-plugins/Makefile ===
# Makefile.in generated by automake 1.17 from Makefile.am.
# sample/sample-plugins/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994-2024 Free Software Foundation, Inc.

# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



#
#  OpenVPN -- An application to securely tunnel IP networks
#             over a single UDP port, with support for SSL/TLS-based
#             session authentication and key exchange,
#             packet encryption, packet authentication, and
#             packet compression.
#
#  Copyright (C) 2002-2025 OpenVPN Inc <sales@openvpn.net>
#

#  SPDX-License-Identifier: GPL-2.0-only
#
#  Copyright (C) 2020-2025 OpenVPN Inc <sales@openvpn.net>
#

am__is_gnu_make = { \
  if test -z '$(MAKELEVEL)'; then \
    false; \
  elif test -n '$(MAKE_HOST)'; then \
    true; \
  elif test -n '$(MAKE_VERSION)' && test -n '$(CURDIR)'; then \
    true; \
  else \
    false; \
  fi; \
}
am__make_running_with_option = \
  case $${target_option-} in \
      ?) ;; \
      *) echo "am__make_running_with_option: internal error: invalid" \
              "target option '$${target_option-}' specified" >&2; \
         exit 1;; \
  esac; \
  has_opt=no; \
  sane_makeflags=$$MAKEFLAGS; \
  if $(am__is_gnu_make); then \
    sane_makeflags=$$MFLAGS; \
  else \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        bs=\\; \
        sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
          | sed "s/$$bs$$bs[$$bs $$bs	]*//g"`;; \
    esac; \
  fi; \
  skip_next=no; \
  strip_trailopt () \
  { \
    flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
  }; \
  for flg in $$sane_makeflags; do \
    test $$skip_next = yes && { skip_next=no; continue; }; \
    case $$flg in \
      *=*|--*) continue;; \
        -*I) strip_trailopt 'I'; skip_next=yes;; \
      -*I?*) strip_trailopt 'I';; \
        -*O) strip_trailopt 'O'; skip_next=yes;; \
      -*O?*) strip_trailopt 'O';; \
        -*l) strip_trailopt 'l'; skip_next=yes;; \
      -*l?*) strip_trailopt 'l';; \
      -[dEDm]) skip_next=yes;; \
      -[JT]) skip_next=yes;; \
    esac; \
    case $$flg in \
      *$$target_option*) has_opt=yes; break;; \
    esac; \
  done; \
  test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
am__rm_f = rm -f $(am__rm_f_notfound)
am__rm_rf = rm -rf $(am__rm_f_notfound)
pkgdatadir = $(datadir)/openvpn
pkgincludedir = $(includedir)/openvpn
pkglibdir = $(libdir)/openvpn
pkglibexecdir = $(libexecdir)/openvpn
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = aarch64-apple-darwin24.6.0
host_triplet = aarch64-apple-darwin24.6.0
subdir = sample/sample-plugins
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/m4/ax_socklen_t.m4 \
	$(top_srcdir)/m4/libtool.m4 $(top_srcdir)/m4/ltoptions.m4 \
	$(top_srcdir)/m4/ltsugar.m4 $(top_srcdir)/m4/ltversion.m4 \
	$(top_srcdir)/m4/lt~obsolete.m4 $(top_srcdir)/m4/pkg.m4 \
	$(top_srcdir)/version.m4 $(top_srcdir)/compat.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
DIST_COMMON = $(srcdir)/Makefile.am $(am__DIST_COMMON)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config.h \
	$(top_builddir)/include/openvpn-plugin.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
AM_V_P = $(am__v_P_$(V))
am__v_P_ = $(am__v_P_$(AM_DEFAULT_VERBOSITY))
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN     " $@;
am__v_GEN_1 = 
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 = 
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
am__DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.plugins \
	README
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = ${SHELL} '/Users/uddr/devel/openvpn/openvpn-build/src/openvpn/missing' aclocal-1.17
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 0
AR = ar
AS = as
AUTOCONF = ${SHELL} '/Users/uddr/devel/openvpn/openvpn-build/src/openvpn/missing' autoconf
AUTOHEADER = ${SHELL} '/Users/uddr/devel/openvpn/openvpn-build/src/openvpn/missing' autoheader
AUTOMAKE = ${SHELL} '/Users/uddr/devel/openvpn/openvpn-build/src/openvpn/missing' automake-1.17
AWK = awk
CC = gcc
CCDEPMODE = depmode=gcc3
CFLAGS = -g -O2 -std=c11 -Wstrict-prototypes -Wold-style-definition -Wconversion -Wno-sign-conversion -Wall -Wextra -Wno-sign-compare -Wno-type-limits -Wno-unused-parameter
CMOCKA_CFLAGS = -I/opt/homebrew/Cellar/cmocka/1.1.7/include
CMOCKA_LIBS = -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
CPP = gcc -E
CPPFLAGS = 
CSCOPE = cscope
CTAGS = ctags
CYGPATH_W = echo
DEFS = -DHAVE_CONFIG_H
DEPDIR = .deps
DLLTOOL = false
DL_LIBS = -ldl
DNS_UPDOWN_TYPE = macos
DSYMUTIL = dsymutil
DUMPBIN = 
ECHO_C = \c
ECHO_N = 
ECHO_T = 
EGREP = /usr/bin/grep -E
ENABLE_UNITTESTS = 
ETAGS = etags
EXEEXT = 
FGREP = /usr/bin/grep -F
FILECMD = file
GIT = git
GREP = /usr/bin/grep
IFCONFIG = /sbin/ifconfig
INSTALL = /opt/homebrew/opt/coreutils/libexec/gnubin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
IPROUTE = 
LD = /Library/Developer/CommandLineTools/usr/bin/ld
LDFLAGS = 
LIBCAPNG_CFLAGS = 
LIBCAPNG_LIBS = 
LIBNL_GENL_CFLAGS = 
LIBNL_GENL_LIBS = 
LIBOBJS = 
LIBPAM_CFLAGS = 
LIBPAM_LIBS = -lpam
LIBS = -lresolv 
LIBTOOL = $(SHELL) $(top_builddir)/libtool
LIPO = lipo
LN_S = ln -s
LTLIBOBJS = 
LT_SYS_LIBRARY_PATH = 
LZ4_CFLAGS = 
LZ4_LIBS = 
LZO_CFLAGS = -I/opt/homebrew/Cellar/lzo/2.10/include/lzo
LZO_LIBS = -L/opt/homebrew/Cellar/lzo/2.10/lib -llzo2
MAKEINFO = ${SHELL} '/Users/uddr/devel/openvpn/openvpn-build/src/openvpn/missing' makeinfo
MANIFEST_TOOL = :
MBEDTLS_CFLAGS = 
MBEDTLS_LIBS = 
MKDIR_P = /opt/homebrew/opt/coreutils/libexec/gnubin/mkdir -p
NETSTAT = netstat
NM = /usr/bin/nm -B
NMEDIT = nmedit
OBJDUMP = objdump
OBJEXT = o
OPENSSL_CFLAGS = -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
OPENSSL_LIBS = -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
OPENVPN_VERSION_MAJOR = 2
OPENVPN_VERSION_MINOR = 7
OPENVPN_VERSION_PATCH = _beta2
OPTIONAL_CRYPTO_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
OPTIONAL_CRYPTO_LIBS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
OPTIONAL_DL_LIBS = -ldl
OPTIONAL_INOTIFY_CFLAGS = 
OPTIONAL_INOTIFY_LIBS = 
OPTIONAL_LIBCAPNG_CFLAGS = 
OPTIONAL_LIBCAPNG_LIBS = 
OPTIONAL_LIBNL_GENL_CFLAGS = 
OPTIONAL_LIBNL_GENL_LIBS = 
OPTIONAL_LZ4_CFLAGS = 
OPTIONAL_LZ4_LIBS = 
OPTIONAL_LZO_CFLAGS = 
OPTIONAL_LZO_LIBS = 
OPTIONAL_PKCS11_HELPER_CFLAGS = 
OPTIONAL_PKCS11_HELPER_LIBS = 
OPTIONAL_SELINUX_LIBS = 
OPTIONAL_SYSTEMD_LIBS = 
OTOOL = otool
OTOOL64 = :
P11KIT_CFLAGS = 
P11KIT_LIBS = 
P11TOOL = 
PACKAGE = openvpn
PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
PACKAGE_NAME = OpenVPN
PACKAGE_STRING = OpenVPN 2.7_beta2
PACKAGE_TARNAME = openvpn
PACKAGE_URL = 
PACKAGE_VERSION = 2.7_beta2
PATH_SEPARATOR = :
PKCS11_HELPER_CFLAGS = 
PKCS11_HELPER_LIBS = 
PKG_CONFIG = /opt/homebrew/bin/pkg-config
PKG_CONFIG_LIBDIR = 
PKG_CONFIG_PATH = 
PLUGINDIR = 
PLUGIN_AUTH_PAM_CFLAGS = 
PLUGIN_AUTH_PAM_LIBS = 
RANLIB = ranlib
RC = 
ROUTE = /sbin/route
RST2HTML = 
RST2MAN = 
SCRIPTDIR = 
SED = /opt/homebrew/opt/gnu-sed/libexec/gnubin/sed
SELINUX_LIBS = 
SET_MAKE = 
SHELL = /bin/sh
SOCKETS_LIBS =  -lresolv
SOFTHSM2_MODULE = 
SOFTHSM2_UTIL = 
STRIP = strip
SYSTEMD_ASK_PASSWORD = 
SYSTEMD_UNIT_DIR = 
TAP_CFLAGS = 
TAP_WIN_COMPONENT_ID = tap0901
TAP_WIN_MIN_MAJOR = 9
TAP_WIN_MIN_MINOR = 9
TEST_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include     -I$(top_srcdir)/include -I/opt/homebrew/Cellar/cmocka/1.1.7/include
TEST_LDFLAGS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto     -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
TMPFILES_DIR = 
VERSION = 2.7_beta2
WINDMC = no
WOLFSSL_CFLAGS = 
WOLFSSL_INCLUDEDIR = 
WOLFSSL_LIBS = 
abs_builddir = /Users/uddr/devel/openvpn/openvpn-build/src/openvpn/sample/sample-plugins
abs_srcdir = /Users/uddr/devel/openvpn/openvpn-build/src/openvpn/sample/sample-plugins
abs_top_builddir = /Users/uddr/devel/openvpn/openvpn-build/src/openvpn
abs_top_srcdir = /Users/uddr/devel/openvpn/openvpn-build/src/openvpn
ac_ct_AR = ar
ac_ct_CC = gcc
ac_ct_DUMPBIN = 
ac_ct_WINDMC = 
am__include = include
am__leading_dot = .
am__quote = 
am__rm_f_notfound = 
am__tar = $${TAR-tar} chof - "$$tardir"
am__untar = $${TAR-tar} xf -
am__xargs_n = xargs -n
bindir = ${exec_prefix}/bin
build = aarch64-apple-darwin24.6.0
build_alias = 
build_cpu = aarch64
build_os = darwin24.6.0
build_vendor = apple
builddir = .
datadir = ${datarootdir}
datarootdir = ${prefix}/share
docdir = ${datarootdir}/doc/${PACKAGE_TARNAME}
dvidir = ${docdir}
exec_prefix = ${prefix}
host = aarch64-apple-darwin24.6.0
host_alias = 
host_cpu = aarch64
host_os = darwin24.6.0
host_vendor = apple
htmldir = ${docdir}
includedir = ${prefix}/include
infodir = ${datarootdir}/info
install_sh = ${SHELL} /Users/uddr/devel/openvpn/openvpn-build/src/openvpn/install-sh
libdir = ${exec_prefix}/lib
libexecdir = ${exec_prefix}/libexec
libsystemd_CFLAGS = 
libsystemd_LIBS = 
localedir = ${datarootdir}/locale
localstatedir = ${prefix}/var
mandir = ${datarootdir}/man
mkdir_p = $(MKDIR_P)
oldincludedir = /usr/include
pdfdir = ${docdir}
plugindir = ${libdir}/openvpn/plugins
prefix = /usr/local
program_transform_name = s,x,x,
psdir = ${docdir}
runstatedir = ${localstatedir}/run
sampledir = $(docdir)/sample
sbindir = ${exec_prefix}/sbin
scriptdir = ${pkglibexecdir}
sharedstatedir = ${prefix}/com
srcdir = .
sysconfdir = ${prefix}/etc
systemdunitdir = 
target_alias = 
tmpfilesdir = 
top_build_prefix = ../../
top_builddir = ../..
top_srcdir = ../..
MAINTAINERCLEANFILES = \
	$(srcdir)/Makefile.in

AM_CPPFLAGS = -I$(top_srcdir) -I$(top_builddir) \
	-I$(top_srcdir)/include -I$(top_builddir)/include


#
# Plug-ins to build - listed entries should not carry any extensions
#
PLUGINS = \
	defer/multi-auth \
	keying-material-exporter-demo/keyingmaterialexporter \
	log/log log/log_v3 \
	simple/base64 \
	simple/simple \
	client-connect/sample-client-connect

all: all-am

.SUFFIXES:
.SUFFIXES: .c .o
$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am $(srcdir)/Makefile.plugins $(am__configure_deps)
	@for dep in $?; do \
	  case '$(am__configure_deps)' in \
	    *$$dep*) \
	      ( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
	        && { if test -f $@; then exit 0; else break; fi; }; \
	      exit 1;; \
	  esac; \
	done; \
	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign sample/sample-plugins/Makefile'; \
	$(am__cd) $(top_srcdir) && \
	  $(AUTOMAKE) --foreign sample/sample-plugins/Makefile
Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
	@case '$?' in \
	  *config.status*) \
	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
	  *) \
	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles)'; \

=== debian/changelog ===
openvpn (2.7.0~beta2-1) experimental; urgency=medium

  * New upstream version 2.7.0~beta2

 -- Bernhard Schmidt <berni@debian.org>  Thu, 25 Sep 2025 18:19:21 +0200

## openvpn 2.7.0~beta3

=== doc/CMakeLists.txt ===
set(_GENERATE_HTML_DOC YES)
set(_GENERATE_MAN_DOC  YES)
set(_MAYBE_PYTHON "")
find_program(RST2HTML NAMES rst2html rst2html.py)
find_program(RST2MAN  NAMES rst2man  rst2man.py)

if (RST2HTML STREQUAL "RST2HTML-NOTFOUND")
    message(STATUS "rst2html not found, not generating HTML documentation")
    set(_GENERATE_HTML_DOC NO)
else ()
    # We only run this for RST2HTML and assume the result would be the same
    # for RST2MAN
    if (DEFINED CACHE{DOCUTILS_NEED_PYTHON})
        if ($CACHE{DOCUTILS_NEED_PYTHON})
            set(_MAYBE_PYTHON ${PYTHON})
        endif ()
    else ()
        execute_process(
            COMMAND ${RST2HTML} --version
            OUTPUT_VARIABLE RST2HTML_VERSION_EXE
            )
        execute_process(
            COMMAND ${PYTHON} ${RST2HTML} --version
            OUTPUT_VARIABLE RST2HTML_VERSION_PY
            )
        set(_DOCUTILS_NEED_PYTHON OFF)
        if(RST2HTML_VERSION_EXE STREQUAL "")
            if(RST2HTML_VERSION_PY STREQUAL "")
                message(STATUS "${RST2HTML} found but not working, not generating documentation")
                set(_GENERATE_HTML_DOC NO)
                set(_GENERATE_MAN_DOC NO)
            else ()
                message(STATUS "${RST2HTML} needs to be executed by ${PYTHON} to work")
                set(_MAYBE_PYTHON ${PYTHON})
                set(_DOCUTILS_NEED_PYTHON ON)
            endif ()
        endif ()
        set(DOCUTILS_NEED_PYTHON ${_DOCUTILS_NEED_PYTHON} CACHE BOOL
            "Whether we need to call python instead of rst2*.py directly")
    endif (DEFINED CACHE{DOCUTILS_NEED_PYTHON})
endif ()
if (RST2MAN STREQUAL "RST2MAN-NOTFOUND")
    message(STATUS "rst2man not found, not generating man pages")
    set(_GENERATE_MAN_DOC NO)
endif ()

set(OPENVPN_SECTIONS
    man-sections/advanced-options.rst
    man-sections/cipher-negotiation.rst
    man-sections/client-options.rst
    man-sections/connection-profiles.rst
    man-sections/encryption-options.rst
    man-sections/generic-options.rst
    man-sections/inline-files.rst
    man-sections/link-options.rst
    man-sections/log-options.rst
    man-sections/management-options.rst
    man-sections/network-config.rst
    man-sections/pkcs11-options.rst
    man-sections/plugin-options.rst
    man-sections/protocol-options.rst
    man-sections/proxy-options.rst
    man-sections/renegotiation.rst
    man-sections/signals.rst
    man-sections/script-options.rst
    man-sections/server-options.rst
    man-sections/tls-options.rst
    man-sections/unsupported-options.rst
    man-sections/virtual-routing-and-forwarding.rst
    man-sections/vpn-network-options.rst
    man-sections/windows-options.rst
    )

set(OPENVPN_EXAMPLES_SECTIONS
    man-sections/example-fingerprint.rst
    man-sections/examples.rst
    )

set(RST_FLAGS --strict)

if (_GENERATE_HTML_DOC)
    list(APPEND ALL_DOCS openvpn.8.html openvpn-examples.5.html)
    add_custom_command(
        OUTPUT openvpn.8.html
        COMMAND ${_MAYBE_PYTHON} ${RST2HTML} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn.8.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn.8.html
        MAIN_DEPENDENCY openvpn.8.rst
        DEPENDS ${OPENVPN_SECTIONS}
        )
    add_custom_command(
        OUTPUT openvpn-examples.5.html
        COMMAND ${_MAYBE_PYTHON} ${RST2HTML} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn-examples.5.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn-examples.5.html
        MAIN_DEPENDENCY openvpn-examples.5.rst
        DEPENDS ${OPENVPN_EXAMPLES_SECTIONS}
        )
endif ()
if (_GENERATE_MAN_DOC)
    list(APPEND ALL_DOCS openvpn.8 openvpn-examples.5)
    add_custom_command(
        OUTPUT openvpn.8
        COMMAND ${_MAYBE_PYTHON} ${RST2MAN} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn.8.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn.8
        MAIN_DEPENDENCY openvpn.8.rst
        DEPENDS ${OPENVPN_SECTIONS}
        )
    add_custom_command(
        OUTPUT openvpn-examples.5
        COMMAND ${_MAYBE_PYTHON} ${RST2MAN} ${RST_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/openvpn-examples.5.rst ${CMAKE_CURRENT_BINARY_DIR}/openvpn-examples.5
        MAIN_DEPENDENCY openvpn-examples.5.rst
        DEPENDS ${OPENVPN_EXAMPLES_SECTIONS}
        )
endif ()

add_custom_target(documentation ALL DEPENDS ${ALL_DOCS})

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -220,7 +220,7 @@
 OPENSSL_LIBS = -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 7
-OPENVPN_VERSION_PATCH = _beta2
+OPENVPN_VERSION_PATCH = _beta3
 OPTIONAL_CRYPTO_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
 OPTIONAL_CRYPTO_LIBS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
@@ -246,10 +246,10 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.7_beta2
+PACKAGE_STRING = OpenVPN 2.7_beta3
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.7_beta2
+PACKAGE_VERSION = 2.7_beta3
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
 PKCS11_HELPER_LIBS = 
@@ -282,7 +282,7 @@
 TEST_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include     -I$(top_srcdir)/include -I/opt/homebrew/Cellar/cmocka/1.1.7/include
 TEST_LDFLAGS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto     -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.7_beta2
+VERSION = 2.7_beta3
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR =

=== src/openvpnserv/CMakeLists.txt ===
if (NOT WIN32)
    return ()
endif ()

project(openvpnserv)

add_executable(openvpnserv)

set(MC_GEN_DIR ${CMAKE_CURRENT_BINARY_DIR}/mc)

target_include_directories(openvpnserv PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/../../
    ../../include/
    ../openvpn/
    ../compat/
    ${MC_GEN_DIR}
    )
target_sources(openvpnserv PRIVATE
    common.c
    interactive.c
    service.c service.h
    validate.c validate.h
    ../tapctl/basic.h
    ../openvpn/wfp_block.c ../openvpn/wfp_block.h
    openvpnserv_resources.rc
    )
target_compile_options(openvpnserv PRIVATE
    -D_UNICODE
    -UNTDDI_VERSION
    -D_WIN32_WINNT=_WIN32_WINNT_VISTA
    )
target_link_libraries(openvpnserv
    advapi32.lib userenv.lib iphlpapi.lib fwpuclnt.lib rpcrt4.lib
    shlwapi.lib netapi32.lib ws2_32.lib ntdll.lib ole32.lib)
if (MINGW)
    target_compile_options(openvpnserv PRIVATE -municode)
    target_link_options(openvpnserv PRIVATE -municode)
endif ()

# below we generate a DLL which contains an event source for event log messages from eventmsg.mc template
file(MAKE_DIRECTORY ${MC_GEN_DIR})
set(MC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/eventmsg.mc)

find_program(MC_COMPILER NAMES mc.exe x86_64-w64-mingw32-windmc i686-w64-mingw32-windmc windmc)

if (NOT MC_COMPILER)
    message(FATAL_ERROR "No message compiler found.")
endif()

add_custom_command(
    OUTPUT ${MC_GEN_DIR}/eventmsg.rc ${MC_GEN_DIR}/eventmsg.h
    COMMAND ${MC_COMPILER} -U -h ${MC_GEN_DIR} -r ${MC_GEN_DIR} ${MC_FILE}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/eventmsg.mc
    VERBATIM
    )

# generate rc file for DLL and header for the service binary
add_custom_target(msg_mc_gen ALL DEPENDS ${MC_GEN_DIR}/eventmsg.rc ${MC_GEN_DIR}/eventmsg.h)

add_library(openvpnservmsg SHARED ${MC_GEN_DIR}/eventmsg.rc)
add_dependencies(openvpnservmsg msg_mc_gen)

if (MSVC)
    set_target_properties(openvpnservmsg PROPERTIES LINK_FLAGS "/NOENTRY")
else()
    set_target_properties(openvpnservmsg PROPERTIES LINKER_LANGUAGE C OUTPUT_NAME "openvpnservmsg")
    target_link_options(openvpnservmsg PRIVATE
        -Wl,--entry=0
        -nostdlib
        -nostartfiles
    )
endif()

add_dependencies(openvpnserv msg_mc_gen)

=== debian/changelog ===
openvpn (2.7.0~beta3-1) experimental; urgency=medium

  * New upstream version 2.7.0~beta3

 -- Bernhard Schmidt <berni@debian.org>  Tue, 14 Oct 2025 00:04:31 +0200

=== debian/control ===
Source: openvpn
Section: net
Priority: optional
Maintainer: Bernhard Schmidt <berni@debian.org>
Uploaders: Jörg Frings-Fürst <debian@jff.email>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1),
 libcap-ng-dev [linux-any],
 liblz4-dev,
 liblzo2-dev,
 libnl-genl-3-dev [linux-any],
 libp11-kit-dev,
 libpam0g-dev,
 libpkcs11-helper1-dev,
 libssl-dev,
 libsystemd-dev [linux-any],
 net-tools [!linux-any],
 pkg-config,
 python3-docutils,
 systemd-dev [linux-any]
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://openvpn.net/community/
Vcs-Git: https://salsa.debian.org/debian/openvpn.git
Vcs-Browser: https://salsa.debian.org/debian/openvpn

Package: openvpn
Architecture: any
Depends:
 debconf | debconf-2.0,
 ${shlibs:Depends},
 ${misc:Depends},
 net-tools [!linux-any],
Suggests:
 openssl,
 resolvconf,
 openvpn-ovpn-dkms,
 openvpn-systemd-resolved,
Recommends: easy-rsa
Description: virtual private network daemon
 OpenVPN is an application to securely tunnel IP networks over a
 single UDP or TCP port. It can be used to access remote sites, make
 secure point-to-point connections, enhance wireless security, etc.
 .
 OpenVPN uses all of the encryption, authentication, and certification
 features provided by the OpenSSL library (any cipher, key size, or
 HMAC digest).
 .
 OpenVPN may use static, pre-shared keys or TLS-based dynamic key exchange. It
 also supports VPNs with dynamic endpoints (DHCP or dial-up clients), tunnels
 over NAT or connection-oriented stateful firewalls (such as Linux's iptables).

## openvpn 2.7.0~rc1

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -220,7 +220,7 @@
 OPENSSL_LIBS = -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 7
-OPENVPN_VERSION_PATCH = _beta3
+OPENVPN_VERSION_PATCH = _rc1
 OPTIONAL_CRYPTO_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
 OPTIONAL_CRYPTO_LIBS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
@@ -246,10 +246,10 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.7_beta3
+PACKAGE_STRING = OpenVPN 2.7_rc1
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.7_beta3
+PACKAGE_VERSION = 2.7_rc1
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
 PKCS11_HELPER_LIBS = 
@@ -282,7 +282,7 @@
 TEST_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include     -I$(top_srcdir)/include -I/opt/homebrew/Cellar/cmocka/1.1.7/include
 TEST_LDFLAGS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto     -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.7_beta3
+VERSION = 2.7_rc1
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
@@ -390,3 +390,4 @@
 	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
 	  *) \
 	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles)'; \
+	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles);; \

=== src/openvpnserv/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,11 @@
 project(openvpnserv)
 
 add_executable(openvpnserv)
+
+include(CheckSymbolExists)
+
+# Some old versions of mingw does not have PATHCCH_OPTIONS enums -- add a check
+check_symbol_exists(PATHCCH_ENSURE_TRAILING_SLASH pathcch.h HAVE_PATHCCH_ENSURE_TRAILING_SLASH)
 
 set(MC_GEN_DIR ${CMAKE_CURRENT_BINARY_DIR}/mc)
 
@@ -31,7 +36,7 @@
     )
 target_link_libraries(openvpnserv
     advapi32.lib userenv.lib iphlpapi.lib fwpuclnt.lib rpcrt4.lib
-    shlwapi.lib netapi32.lib ws2_32.lib ntdll.lib ole32.lib)
+    shlwapi.lib netapi32.lib ws2_32.lib ntdll.lib ole32.lib pathcch.lib)
 if (MINGW)
     target_compile_options(openvpnserv PRIVATE -municode)
     target_link_options(openvpnserv PRIVATE -municode)

=== debian/changelog ===
openvpn (2.7.0~rc1-1) experimental; urgency=medium

  * New upstream version 2.7.0~rc1

 -- Bernhard Schmidt <berni@debian.org>  Sun, 02 Nov 2025 10:33:55 +0100

=== debian/tests/control ===
Tests: server-setup-with-ca
Depends: openvpn, easy-rsa
Restrictions: needs-root, isolation-machine, allow-stderr

Tests: server-setup-with-static-key
Restrictions: needs-root, isolation-machine, allow-stderr

Tests: unit-tests
Depends: libcmocka-dev, @builddeps@
Restrictions: allow-stderr

## openvpn 2.7.0~rc2

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,7 +114,7 @@
     check_and_add_compiler_flag(-Wstrict-prototypes StrictPrototypes)
     check_and_add_compiler_flag(-Wold-style-definition OldStyleDefinition)
     add_compile_options(-Wconversion -Wno-sign-conversion)
-    add_compile_options(-Wextra -Wno-sign-compare -Wno-type-limits -Wno-unused-parameter)
+    add_compile_options(-Wextra -Wno-sign-compare -Wno-unused-parameter)
     # clang doesn't have the different levels but also doesn't include it in -Wextra
     check_and_add_compiler_flag(-Wimplicit-fallthrough=2 GCCImplicitFallthrough)
     if (WIN32)

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -154,7 +154,7 @@
 AWK = awk
 CC = gcc
 CCDEPMODE = depmode=gcc3
-CFLAGS = -g -O2 -std=c11 -Wstrict-prototypes -Wold-style-definition -Wconversion -Wno-sign-conversion -Wall -Wextra -Wno-sign-compare -Wno-type-limits -Wno-unused-parameter
+CFLAGS = -g -O2 -std=c11 -Wstrict-prototypes -Wold-style-definition -Wconversion -Wno-sign-conversion -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter
 CMOCKA_CFLAGS = -I/opt/homebrew/Cellar/cmocka/1.1.7/include
 CMOCKA_LIBS = -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
 CPP = gcc -E
@@ -220,7 +220,7 @@
 OPENSSL_LIBS = -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 7
-OPENVPN_VERSION_PATCH = _rc1
+OPENVPN_VERSION_PATCH = _rc2
 OPTIONAL_CRYPTO_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
 OPTIONAL_CRYPTO_LIBS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
@@ -246,10 +246,10 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.7_rc1
+PACKAGE_STRING = OpenVPN 2.7_rc2
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.7_rc1
+PACKAGE_VERSION = 2.7_rc2
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
 PKCS11_HELPER_LIBS = 
@@ -282,7 +282,7 @@
 TEST_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include     -I$(top_srcdir)/include -I/opt/homebrew/Cellar/cmocka/1.1.7/include
 TEST_LDFLAGS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto     -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.7_rc1
+VERSION = 2.7_rc2
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR = 
@@ -391,3 +391,4 @@
 	  *) \
 	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles)'; \
 	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__maybe_remake_depfiles);; \
+	esac;

=== debian/changelog ===
openvpn (2.7.0~rc2-2devuan1) unstable; urgency=medium

  * Merge tag debian/2.7.0_rc2-2.

 -- Mark Hindley <mark@hindley.org.uk>  Sat, 22 Nov 2025 19:24:14 +0000

openvpn (2.7.0~rc2-2) unstable; urgency=medium

  * New upstream version 2.7.0~rc2 to unstable
    - CVE-2025-12106
      IPv6 address parsing: fix buffer overread on invalid input
    - CVE-2025-13086
      HMAC verification check: fix incorrect memcmp() call (Closes: #1121086)

  * Highlights from the 2.7 upstream release
    - Multi-socket support for servers -- Handle multiple
      addresses/ports/protocols within one server
    - Support for new upstream DCO Linux kernel module
      + replaces previous ovpn-dco-v2 out-of-tree kernel module with an
        official kernel module available since Linux 6.16+

 -- Bernhard Schmidt <berni@debian.org>  Thu, 20 Nov 2025 23:31:00 +0100

openvpn (2.6.15-1devuan1) unstable; urgency=medium

  * Merge tag debian/2.6.15-1.

 -- Mark Hindley <mark@hindley.org.uk>  Mon, 27 Oct 2025 07:15:41 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: openvpn
 Section: net
 Priority: optional
-Maintainer: Bernhard Schmidt <berni@debian.org>
-Uploaders: Jörg Frings-Fürst <debian@jff.email>
+Maintainer: Devuan Developers <devuan-dev@lists.dyne.org>
+Uploaders:
+	Mark (LeePen) Hindley <mark@hindley.org.uk>,
+	Ben Walsh <b@wumpster.com>
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1),
@@ -14,16 +16,15 @@
  libpam0g-dev,
  libpkcs11-helper1-dev,
  libssl-dev,
- libsystemd-dev [linux-any],
  net-tools [!linux-any],
  pkg-config,
  python3-docutils,
- systemd-dev [linux-any]
 Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
 Homepage: https://openvpn.net/community/
-Vcs-Git: https://salsa.debian.org/debian/openvpn.git
-Vcs-Browser: https://salsa.debian.org/debian/openvpn
+Vcs-Git: https://git.devuan.org/devuan/openvpn.git
+Vcs-Browser: https://git.devuan.org/devuan/openvpn
+Origin: Devuan
 
 Package: openvpn
 Architecture: any
@@ -35,8 +36,6 @@
 Suggests:
  openssl,
  resolvconf,
- openvpn-ovpn-dkms,
- openvpn-systemd-resolved,
 Recommends: easy-rsa
 Description: virtual private network daemon
  OpenVPN is an application to securely tunnel IP networks over a

## openvpn 2.7.0~rc3

=== CMakeLists.txt ===
--- 
+++ 
@@ -145,7 +145,6 @@
     set(TARGET_ANDROID YES)
     set(ENABLE_ASYNC_PUSH YES)
     set(ENABLE_SITNL YES)
-    set(HAVE_LINUX_TYPES_H 1)
     # Wacky workaround as OpenSSL package detection is otherwise broken (https://stackoverflow.com/questions/45958214/android-cmake-could-not-find-openssl)
     list(APPEND CMAKE_FIND_ROOT_PATH ${OPENSSL_ROOT_DIR})
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
@@ -153,9 +152,6 @@
     set(ENABLE_ASYNC_PUSH YES)
     set(ENABLE_LINUXDCO YES)
     set(ENABLE_SITNL YES)
-    set(HAVE_DECL_SO_MARK YES)
-    set(ENABLE_FEATURE_TUN_PERSIST 1)
-    set(HAVE_LINUX_TYPES_H 1)
     set(ENABLE_DCO YES)
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
     set(TARGET_FREEBSD YES)
@@ -244,6 +240,7 @@
 
 check_symbol_exists(chsize io.h HAVE_CHSIZE)
 check_symbol_exists(getrlimit sys/resource.h HAVE_GETRLIMIT)
+check_symbol_exists(strsep string.h HAVE_STRSEP)
 
 # Some OS (e.g. FreeBSD) need some basic headers to allow
 # including network headers
@@ -258,8 +255,6 @@
 check_include_files(dmalloc.h HAVE_DMALLOC_H)
 check_include_files(fcntl.h HAVE_FCNTL_H)
 check_include_files(err.h HAVE_ERR_H)
-check_include_files(linux/if_tun.h HAVE_LINUX_IF_TUN_H)
-check_include_files(linux/sockios.h HAVE_LINUX_SOCKIOS_H)
 check_include_files(netdb.h HAVE_NETDB_H)
 check_include_files("${NETEXTRA};netinet/in6.h" HAVE_NETINET_IN_H)
 check_include_files(net/if.h HAVE_NET_IF_H)
@@ -302,3 +297,6 @@
         set(CMAKE_REQUIRED_INCLUDES ${MBED_INCLUDE_PATH})
     endif ()
     if (NOT (MBED_LIBRARY_PATH STREQUAL ""))
+        set(CMAKE_REQUIRED_LINK_OPTIONS "-L${MBED_LIBRARY_PATH}")
+    endif ()
+    set(CMAKE_REQUIRED_LIBRARIES "mbedtls;mbedx509;mbedcrypto")

=== sample/sample-plugins/Makefile ===
--- 
+++ 
@@ -220,7 +220,7 @@
 OPENSSL_LIBS = -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPENVPN_VERSION_MAJOR = 2
 OPENVPN_VERSION_MINOR = 7
-OPENVPN_VERSION_PATCH = _rc2
+OPENVPN_VERSION_PATCH = _rc3
 OPTIONAL_CRYPTO_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include
 OPTIONAL_CRYPTO_LIBS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto
 OPTIONAL_DL_LIBS = -ldl
@@ -246,10 +246,10 @@
 PACKAGE = openvpn
 PACKAGE_BUGREPORT = openvpn-users@lists.sourceforge.net
 PACKAGE_NAME = OpenVPN
-PACKAGE_STRING = OpenVPN 2.7_rc2
+PACKAGE_STRING = OpenVPN 2.7_rc3
 PACKAGE_TARNAME = openvpn
 PACKAGE_URL = 
-PACKAGE_VERSION = 2.7_rc2
+PACKAGE_VERSION = 2.7_rc3
 PATH_SEPARATOR = :
 PKCS11_HELPER_CFLAGS = 
 PKCS11_HELPER_LIBS = 
@@ -282,7 +282,7 @@
 TEST_CFLAGS =  -I/opt/homebrew/Cellar/openssl@3/3.5.1/include     -I$(top_srcdir)/include -I/opt/homebrew/Cellar/cmocka/1.1.7/include
 TEST_LDFLAGS =  -L/opt/homebrew/Cellar/openssl@3/3.5.1/lib -lssl -lcrypto     -L/opt/homebrew/Cellar/cmocka/1.1.7/lib -lcmocka
 TMPFILES_DIR = 
-VERSION = 2.7_rc2
+VERSION = 2.7_rc3
 WINDMC = no
 WOLFSSL_CFLAGS = 
 WOLFSSL_INCLUDEDIR =

=== src/openvpnserv/CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,6 @@
 add_executable(openvpnserv)
 
 include(CheckSymbolExists)
-
-# Some old versions of mingw does not have PATHCCH_OPTIONS enums -- add a check
-check_symbol_exists(PATHCCH_ENSURE_TRAILING_SLASH pathcch.h HAVE_PATHCCH_ENSURE_TRAILING_SLASH)
 
 set(MC_GEN_DIR ${CMAKE_CURRENT_BINARY_DIR}/mc)

=== debian/changelog ===
openvpn (2.7.0~rc3-1ubuntu1) resolute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/control: Demote easy-rsa to Suggests (universe package).
    - debian/openvpn@.service: Add '--script-security 2' similar to what
      got added to debian/openvpn.init.d ages ago (LP #1454725)
    - d/t/control: Move to isolation-container to enable armhf/LXD coverage.
      (LP #2104146)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 Dec 2025 12:07:19 +0100

openvpn (2.7.0~rc3-1) unstable; urgency=medium

  * New upstream version 2.7.0~rc3
    - DCO (primarily Linux): improve handling of bulk notifications from
      kernel (do not lose notifications, do not crash) (github#900)

 -- Bernhard Schmidt <berni@debian.org>  Sat, 29 Nov 2025 00:21:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,8 @@
 Source: openvpn
 Section: net
 Priority: optional
-Maintainer: Devuan Developers <devuan-dev@lists.dyne.org>
-Uploaders:
-	Mark (LeePen) Hindley <mark@hindley.org.uk>,
-	Ben Walsh <b@wumpster.com>
+Maintainer: Bernhard Schmidt <berni@debian.org>
+Uploaders: Jörg Frings-Fürst <debian@jff.email>
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1),
@@ -16,15 +14,16 @@
  libpam0g-dev,
  libpkcs11-helper1-dev,
  libssl-dev,
+ libsystemd-dev [linux-any],
  net-tools [!linux-any],
  pkg-config,
  python3-docutils,
+ systemd-dev [linux-any]
 Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
 Homepage: https://openvpn.net/community/
-Vcs-Git: https://git.devuan.org/devuan/openvpn.git
-Vcs-Browser: https://git.devuan.org/devuan/openvpn
-Origin: Devuan
+Vcs-Git: https://salsa.debian.org/debian/openvpn.git
+Vcs-Browser: https://salsa.debian.org/debian/openvpn
 
 Package: openvpn
 Architecture: any
@@ -36,7 +35,8 @@
 Suggests:
  openssl,
  resolvconf,
-Recommends: easy-rsa
+ openvpn-systemd-resolved,
+ easy-rsa
 Description: virtual private network daemon
  OpenVPN is an application to securely tunnel IP networks over a
  single UDP or TCP port. It can be used to access remote sites, make
